# Themis 0.9 

Themis is a high-level cryptographic services library. Themis was designed to provide complicated cryptosystems in easy-to-use infrastructure, suitable for modern rapid development. It is open source, Apache 2 Licensed.

Themis is set to provide a wide set of instruments, three main of which are being present in current, 0.9 release:

* Secure Message: a simple encrypted messaging solutions for widest scope of application
* Secure Session: safer, session-oriented messaging solution with better security guarantees (and some more strict demands in it's implementation)
* Secure Cell: a multi-mode encrypted container, suitable for storing anything from encrypted files to database records and format-preserved strings.

# Quickstart Crash Course

1. Fetch the repository: git clone https://github.com/cossacklabs/themis.git
2. Have OpenSSL/LibreSSL + OpenSSL/LibreSSL Dev pack (libssl-dev) installed at typical paths: /usr/lib /usr/include. 
3. Have typical gcc environment installed
4. Fire 'make install' and you're good most of the cases
5. Dive into [our wiki](https://github.com/cossacklabs/themis/wiki) for the docs, take a look at docs/examples for examples. 

It is really advisable to [go the long way and read the docs](https://github.com/cossacklabs/themis/wiki/2.1-Building-and-installing), but god blessed the brave.
